--
-- Cvicenie 5
-- Priklad 13
--
-- Autor: Ladislav Vastag III.rocnik SPZ
--
-- Definujte funkciu filterTree pre binarny strom a pomocou nej z binar-
-- neho stromu celych cisel vytvorte dvojicu binarnych stromov, jeden
-- iba s nezapornymi, druhy iba so zapornymi cislami.
--

data Btree a = Val a | Bin a (Btree a) (Btree a) | NULL deriving (Show, Eq, Ord)


{-

                          +---+
                          | 8 | Bin
                          +---+
                         /     \
                        /       \
                       /         \
                  +---+           +---+
                  | -3| Bin       | 7 | Bin
                  +---+           +---+
                 /     \               \
                /       \               \
               /         \               \ 
          +---+          +---+            +---+
          |-7 | Bin      | 4 | Val        |16 | Bin
          +---+          +---+            +---+
               \                         /     \
                \                       /       \
                 \                     /         \
                  +---+           +---+           +---+
                  |-4 | Bin       |14 | Bin       |20 | Bin
                  +---+           +---+           +---+

                        exampleTree
-}

-- Zapis stromu pomocou abstrakneho datoveho typu
exampleTree = Bin 8 (
                      Bin (-3) 
                               (Bin (-7) NULL (Val (-4)))
                               (Val 4)
                    )
                    (
                      Bin 9 
                            NULL 
                            (Bin 16 (Val 14) (Val 20))
                    )


filterTree x = listToTrees NULL NULL (treeToListPreorder x)
    where 
          -- Vytvori zozman vrcholov stromu algoritmom PREORDER
          treeToListPreorder (Val x) = [x]
          treeToListPreorder (Bin x NULL NULL) = [x]
          treeToListPreorder (Bin x left NULL) = [x] ++ treeToListPreorder left
          treeToListPreorder (Bin x NULL rigth) = [x] ++ treeToListPreorder rigth
          treeToListPreorder (Bin x left rigth) = [x] ++ treeToListPreorder left 
                                                  ++ treeToListPreorder rigth 

          -- Pridanie noveho vrcholu do stromu
          addVertex NULL x = (Val x)
          addVertex (Val x) y | y < x = (Bin x (Val y) NULL)
                              | y > x = (Bin x NULL (Val y))
                              | otherwise = (Val x)
          addVertex (Bin x left rigth) y 
                              | y < x = (Bin x (addVertex left y) rigth)
                              | y > x = (Bin x left (addVertex rigth y))
                              | otherwise = (Bin x left rigth)

          -- Vytvori zozonamu cisiel dvojicu stromov jeden s nezapornymi a druhy
          -- so zapornymi vrcholmi.
          listToTrees x y [] = (x,y)
          listToTrees x y (z:zs) | 0 <= z = listToTrees (addVertex x z) y zs
                                 |otherwise = listToTrees x (addVertex y z) zs

main = filterTree exampleTree