--
-- Cvicenie 5
-- Priklad 8
--
-- Autor: Ladislav Vastag
--
-- Definujte funkciu foldGtree pre vseobecnz strom. Potom, na zaklade
-- tejto funkcie definujte funkciu ktora scita vsetky hodnoty n vseobec-
-- nych stromov celych cisel za predpokladu, ze tieto vseobecne stromy
-- su hodnotami zoznamu. Funkcia je teda typu [Gtree Int] -> Int.
--

data Gtree a = Val Int | Bin Int [Gtree Int]  deriving (Show)

{-
    Vseobecny strom - kazdy vrchol moze mat lubovolny pocet synov 

                      +---+
                      | 2 |
                      +---+
                     /  |  \
                    /   |   \
                   /    |    \
              +---+   +---+   +---+
              | 5 |   | 6 |   | 7 |
              +---+   +---+   +---+
                |
                |
                |
              +---+
              | 10|
              +---+
             /     \ 
            /       \
           /         \
      +---+           +---+
      | 3 |           | 8 |
      +---+           +---+
                            
                              exanpleTree
-}

 
exampleTree = Bin 2 [Bin 5 [Bin 10 [Val 3, Val 8 ]] , Val 6, Val 7 ]

--
-- Zoznam stromov 
-- Snazil som sa naformatovat zapis tak aby bol co najprehladnejsi a aby sa co
-- najviac priblizil grafickej reprezentacii
--
exampleListOfTrees = 
     [ -- Prvy stron == exampleTree
       Bin 2 [ 
               Bin 5 [
                       Bin 10 [
                                Val 3,
                                Val 8
                              ]
                     ],
               Val 6,
               Val 7
             ],

       -- Druhy strom
       Bin 45 [ 
                Bin 85 [ 
                         Bin 10 [
                                  Val 32,
                                  Val 8
                                ]
                       ],
                Bin 64 [
                         Val 15,
                         Val 28
                       ],
                Val 7
              ],

       -- Treti strom
       Bin 5 [
               Bin 10 [
                        Val 3,
                        Val 8
                      ]
             ],

       -- Stvrty strom
       Bin 10 [
                Val 3,
                Val 8
              ]
     ]

--
-- Definovanie fukcie foldGtree
--
foldlGtree f n (Val x) = f n x
foldlGtree f n (Bin x (y:ys)) = foldlGtree_1 f (foldlGtree f (f n x) y) ys
     where
     foldlGtree_1 f n [] = n
     foldlGtree_1 f n ((Val x):zs) = foldlGtree_1 f (f n x) zs
     foldlGtree_1 f n ((Bin x (y:ys)):zs) =
                  foldlGtree_1 f (foldlGtree_1 f (foldlGtree f (f n x) y) ys) zs

--
-- Definovanie funkcie, ktora spocita hodnoty vrcholov vseobecnych stromov
--
sumOfVertexes :: [Gtree Int] -> Int
sumOfVertexes x = foldl (+) 0 [foldlGtree (+) 0 y | y <- x]

main = sumOfVertexes exampleListOfTrees