--
-- Cvicenie 5
-- Priklad 9
--
-- Autor: Ladislav Vastag III.rocnik SPZ
--
-- Je dany typ nat ::= Zero | Succ nat, ktoremu patria cele nezaporne
-- cisla. Definujte aritmeticke operacie a operaci porovnania:
--
--   (+.), (-.), (*.), (/.) :: Nat -> Nat -> Nat
--   (>=.) :: Nat -> Nat -> Bool
--
-- ako aj transformacne funkcie:
--
--   fromNat :: Nat -> Int
--   toNat :: Int -> Nat
--
-- V defnicii (/.) vyuzite (>=.) a urte hodnotu vrazu (toNat 2 *. toNat 2).
--

data Nat = Zero | Succ Nat deriving (Show)

-- Ak pouzijem instance Show a instance Eq program havaruje
-- instance Show Nat
instance Eq  Nat
instance Ord Nat
instance Num Nat

(>=.) :: Nat -> Nat -> Bool
(>=.) Zero Zero = True
(>=.) Zero (Succ n) = False
(>=.) (Succ n) Zero = True
(>=.) (Succ m) (Succ n) = m >=. n

(+.) :: Nat -> Nat -> Nat
(+.) Zero n = n
(+.) (Succ m) n = Succ (m +. n)

(-.) :: Nat -> Nat -> Nat
(-.) n Zero = n
(-.) Zero n = error("Substract error!\nNat can not be negativ!")
(-.) (Succ m) (Succ n) = m -. n

(*.) :: Nat -> Nat -> Nat
(*.) (Succ Zero) n = n
(*.) n (Succ Zero) = n
(*.) n Zero = Zero
(*.) m n = m +. (m *. (n-.(Succ Zero)))

(/.) :: Nat -> Nat -> Nat
(/.) m Zero = error("Division error!\nDivide by zero!")
(/.) m n | m >=. n = Succ ((m -. n)/.n)
         | otherwise = Zero
    

fromNat :: Nat -> Int
fromNat Zero = 0
fromNat (Succ n) = 1 + fromNat n

toNat :: Int -> Nat
toNat x | x < 0 = error("Conversion error!\nNat can not be negativ!")
        | x == 0 = Zero
        | otherwise = Succ (toNat (x-1))

main = toNat 2 *. toNat 2