--
-- Cvicenie 6
-- Priklad 3
--
-- Autor: Ladislav Vastag III.rocnik SPZ
--
-- Definujte abstraktny typ Nat s operaciami scitania, odcitania, naso-
-- benia a delenia ((+.),(-.),(*.),(/.)) na mnozine nezapornych ci-
-- sel a s operaciou pre transformaciu celeho nezaporneho cisla do Int
-- (fromNat :: a -> Int) a to pre reprezentaciu Int a pre reprezenta-
-- ciu algebraickam typom Nat definovanm nasledovne:
-- 
--     data Nat = Zero | Succ Nat
--
-- Potom definujte mimo abstraktneho typu funkciu toNAT :: Int -> Nat
-- pre zobrazenie z reprezentacie Int do Nat.
-- Pripad Nat rieste pomocou operacii definovanych v pripade Int.
--

data Nat = Zero | Succ Nat deriving (Show)

class Natural a where
    (>=.) :: a -> a -> Bool
    (+.) :: a -> a -> a
    (-.) :: a -> a -> a
    (*.) :: a -> a -> a
    (/.) :: a -> a -> a

instance Natural Nat where
    (>=.) Zero Zero = True
    (>=.) Zero (Succ n) = False
    (>=.) (Succ n) Zero = True
    (>=.) (Succ m) (Succ n) = m >=. n

    (+.) Zero n = n
    (+.) (Succ m) n = Succ (m +. n)

    (-.) n Zero = n
    (-.) Zero n = error("Substract error!\nNat can not be negativ!")
    (-.) (Succ m) (Succ n) = m -. n

    (*.) (Succ Zero) n = n
    (*.) n (Succ Zero) = n
    (*.) n Zero = Zero
    (*.) m n = m +. (m *. (n-.(Succ Zero)))

    (/.) m Zero = error("Division error!\nDivide by zero!")
    (/.) m n | m >=. n = Succ ((m -. n)/.n)
             | otherwise = Zero

        
fromNat :: Nat -> Int
fromNat Zero = 0
fromNat (Succ n) = 1 + fromNat n

toNat :: Int -> Nat
toNat x | x < 0 = error("Conversion error!\nNat can not be negativ!")
        | x == 0 = Zero
        | otherwise = Succ (toNat (x-1))