--
-- Cvicenie 6
-- Priklad 4
--
-- Autor: Ladislav Vastag III.rocnik SPZ
-- 
-- Definujte abstraktn typ Queue s operaciami:
--
--    start :: QUEUE a
--    empty :: QUEUE a -> Bool
--    join :: a -> QUEUE a -> QUEUE a
--    front :: QUEUE a -> a
--    reduce :: QUEUE a -> QUEUE a
--
-- pri reprezentacii fronty typom type QUEUE a = [a]. pre pripady ce-
-- lych a realnych cisel, logickych hodnot, znakov, dvojic a zoznamov,
-- pricom ma platit: 
--
-- start - vytvori prazdnu frontu
-- empty - zisti ci je fronta prazdna
-- join - prida hodnotu na koniec fronty (pri danej reprezentacii
--        na koniec zoznamu), t.j. predlzi frontu o jeden prvok
-- front - vrati hodnotu zo zaciatku fronty (nemeni dlzku fronty)
-- reduce - odoberie prvok zo zaciatku fronty, t.j. skrati frontu o jeden prvok
-- 
-- V ramci typovej triedy implementujte operacie join, front a reduce, ostatne
-- mimo. front a reduce nie su definovan pre prazdnu frontu.
-- Potom definujte funkciu
--
--    mkqueue:: Queue a => [a] -> QUEUE a
--
-- ktora vytvori zo zoznamu frontu pomocou operacii abstraktneho typu
-- Queue, pricom prvy prvok zoznamu bude zaradeny do fronty ako prvy.
--

type QUEUE a = [a]

class Que a where
    join :: a -> QUEUE a -> QUEUE a
    join x xq = xq ++ [x]
    
    front :: QUEUE a -> a
    front  (x:xs) = x
    
    reduce :: QUEUE a -> QUEUE a
    reduce (x:xq) =  xq



instance Que Int
instance Que Integer
-- instance Que Fractional
instance Que Char
instance Que (a,b)
instance Que [a]

start :: QUEUE a
start = []
    
empty :: QUEUE a -> Bool
empty [] = True
empty _ = False


mkqueue [] = []
mkqueue (x:xs) = toQueue xs (join x start)
         where toQueue [] x = x
               toQueue (x:xs) y = toQueue xs (join x y)