--
-- Cvicenie 6
-- Priklad 5
--
-- Autor: Ladislav Vastag III.rocnik SPZ
-- 
-- Definujte abstraktny typ Stack s operaciami:
--
--     bottom :: STACK a
--     empty :: STACK a -> Bool
--     push :: a -> STACK a -> STACK a
--     top :: STACK a -> a
--     pop :: STACK a -> STACK a
--
-- pri reprezentacii zasobnika typom data STACK a = Bot | Item a (STACK a).
-- pre pripady celych a realnych cisiel, logickych hodnot, znakov, dvojic a
-- zoznamov, pricom m plati: 
-- 
-- bottom - vytvori prazdny zasobnik. 
-- empty - zisti, i je zasobnik prazdny.
-- push - ulozi hodnotu na vrchol zasobnika, t.j. zvacsi zasobnik o jeden prvok. 
-- top - hodnotou je hodnota na vrchole (nemeni zasobnik). 
-- pop - vyberie prvok zo zasobnika, t.j. zmens zasobnik o jeden prvok.
--
-- V ramci typovej triedy implementujte operacie push, pop a top, ostatne mimo. 
-- Pri prazdnom zasobniku pop a top nemaju definovanu hodnotu. Potom definujte
-- funkciu
-- 
--        mkstack :: Stack a => [a] -> STACK a
--
-- ktora ulozi zoznam do zasobnika pomocou operacii abstraktneho typu
-- Stack, pricom prvy prvok zoznamu bude zaradeny do zsobnika ako prvy.
-- Rozsirte abstraktne typy Eq a Ord o operacie porovnania dvoch zasobnikov.
-- Pritom je zname, ze operacia (/=) je definovan v triede Eq na zklade (==) 
-- a opercie (<), (>) a (>=) s definovan v triede Ord na zklade opercie(<=).
--

data STACK a = Bot | Item a (STACK a) deriving (Show)

class Stack a where
    push :: a -> STACK a -> STACK a
    push x y = (Item x y)

    top :: STACK a -> a
--    top Bot = error("There was executed top operation on empty stack!!")
    top (Item x y) = x
    
    pop :: STACK a -> STACK a
--    pop Bot = Bot
    pop (Item x y) = y


bottom :: STACK a
bottom = Bot

empty :: STACK a -> Bool
empty Bot = True
epmty (Item x y) = False


instance (Eq a) => Eq (STACK a) where
    (==) Bot Bot = True
    (==) (Item x y) (Item u v) = x == u && y == v

instance (Ord a) => Ord (STACK a) where
    (<=) Bot Bot = True
    (<=) Bot (Item x y) = True
    (<=) (Item x y) (Item u v) = x <= u && y <= v

instance Stack Int
instance Stack Integer
instance Stack Bool
instance Stack Char
instance Stack (a,b)
instance Stack [a]


mkstack x = toStack x bottom
        where toStack [] y = y
              toStack (x:xs) y = toStack xs (push x y)